#ifndef _fencer_tileset_h
#define _fencer_tileset_h

#include "cjson/cJSON.h"
#include "sprite.h"
#include "shape.h"

typedef enum TileCollision {
    TILE_COL_NONE,
    TILE_COL_RECT,
    TILE_COL_SHAPE
} TileCollision;

typedef struct TileDef TileDef;
typedef struct Tileset Tileset;

extern Tileset* tileset_from_json(cJSON* json);
extern Tileset* tileset_load(size_t uid);
extern TileDef* tileset_get_tiledef(Tileset* self, size_t t);
extern void tileset_destroy(Tileset* self);

extern Sprite* tiledef_get_sprite(const TileDef* self);
extern Shape* tiledef_get_shape(TileDef* self);

#endif // !_fencer_tileset_h
